require 'tilt'
require 'slim'

module Odex
  module Templates
    module Helpers
      def render template, locals = {}, options = {}, &block
        template_cache.fetch(template) do
          Slim::Template.new(template, options)
        end.render(self, locals, &block)
      end

      def template_cache
        Thread.current[:template_cache] ||= Tilt::Cache.new
      end
    end

    def self.module_is_registered app
      app.helpers Helpers
    end
  end
end
